> For the complete documentation index, see [llms.txt](https://docs.quipuswap.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.quipuswap.com/smart-contracts/quipuswap-stable-swap-dex/developer-module/storage-and-action-types.md).

# Storage & action types

### Developer actions

Action type for module setters.

{% content-ref url="/pages/eA46ciGNfFQb8Yu8eg7H" %}
[Developer setter entrypoints](/smart-contracts/quipuswap-stable-swap-dex/developer-module/developer-setter-entrypoints.md)
{% endcontent-ref %}

```pascaligo
type dev_action_t       is
| Set_dev_address         of address
| Set_dev_fee             of nat
```

### Developer storage

<table><thead><tr><th width="206.35180549489237">Field</th><th width="166" align="center">Type</th><th width="237">Hint</th><th>Description</th></tr></thead><tbody><tr><td>dev_address</td><td align="center"><code>address</code></td><td></td><td>Address of developer</td></tr><tr><td>dev_fee</td><td align="center"><code>nat</code></td><td>(decimal) multiplied by <code>fee_denominator</code> (1e10)</td><td>fee rate that goes to dev.</td></tr><tr><td>dev_lambdas</td><td align="center"><code>big_map(nat, bytes)</code></td><td></td><td>Developer action lambdas</td></tr></tbody></table>

```pascaligo
type dev_storage_t      is [@layout:comb] record [
  dev_address             : address;
  dev_fee                 : nat;
  dev_lambdas             : big_map(nat, bytes);
]
```

#### Lambda type

Lambda is stored as `bytes`, packed from `dev_func_t`.

```pascaligo
type dev_func_t is (dev_action_t * dev_storage_t) -> dev_storage_t
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.quipuswap.com/smart-contracts/quipuswap-stable-swap-dex/developer-module/storage-and-action-types.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
